#!/bin/bash    
#
# kconfig: 345 80 20    
# description: start the integration service   
#    
# Source function library    
#. /etc/rc.d/init.d/functions    

JAVA_HOME="$( readlink -f "$( which java )" | sed "s:bin/.*$::" )"
APP_HOME=/data/hanshow/integration/Hanshow-Integration-C625-B06
MAIN_CLASS=com.hanshows.cdi.yonghuichaoshi.DataExtractor

APP_PID="$APP_HOME/app-daemon.pid"

case "$1" in
start)
    echo "Starting Integration Service..."    
    if [ -f $APP_PID ] ; then
        echo "Integration Service has already started. Please delete $APP_PID if otherwise."
    else
        bash -c "cd $APP_HOME && nohup $JAVA_HOME/bin/java -Xms1024M -Xmx1024M -Dfile.encoding=utf-8 -classpath config:lib/*:. $MAIN_CLASS >/dev/null 2>&1 & echo \$! > $APP_PID"
        echo "Integration Service started"
    fi
    ;;
stop)
    echo "Stopping Integration Service..."   
    if [ -f $APP_PID ] ; then
        PID=`cat $APP_PID`
        pkill -P $PID
        if kill -9 $PID ; then
            echo "Integration Service stopped"
        else
            echo "Integration Service could not be stopped"
        fi
        rm -f $APP_PID
    fi
    ;;

*)
    echo "Usage: $prog {start|stop}"    
    ;;
esac
exit 0

