@echo off

setlocal

set "SELF=%~dp0%service.bat"
rem Guess APP_HOME if not defined
set "CURRENT_DIR=%cd%"
rem CD to the upper dir
cd ..
set "APP_HOME=%cd%"
echo "APP_HOME IS %cd%"
rem Make sure prerequisite environment variables are set
if not "%JAVA_HOME%" == "" goto gotJdkHome
if not "%JRE_HOME%" == "" goto gotJreHome
echo Neither the JAVA_HOME nor the JRE_HOME environment variable is defined
echo Service will try to guess them from the registry.
goto okJavaHome
:gotJreHome
if not exist "%JRE_HOME%\bin\java.exe" goto noJavaHome
if not exist "%JRE_HOME%\bin\javaw.exe" goto noJavaHome
goto okJavaHome
:gotJdkHome
if not exist "%JAVA_HOME%\jre\bin\java.exe" goto noJavaHome
if not exist "%JAVA_HOME%\jre\bin\javaw.exe" goto noJavaHome
if not exist "%JAVA_HOME%\bin\javac.exe" goto noJavaHome
if not "%JRE_HOME%" == "" goto okJavaHome
set "JRE_HOME=%JAVA_HOME%\jre"
goto okJavaHome
:noJavaHome
echo The JAVA_HOME environment variable is not defined correctly
echo This environment variable is needed to run this program
echo NB: JAVA_HOME should point to a JDK not a JRE
goto end
:okJavaHome
if "%PROCESSOR_ARCHITECTURE%"=="x86" goto x86
if "%PROCESSOR_ARCHITECTURE%"=="AMD64" goto x64

:x86
echo 32bit OS found.
set "EXECUTABLE=%APP_HOME%\bin\x86\Integration.exe"
goto okExec

:x64
echo 64bit OS found.
set "EXECUTABLE=%APP_HOME%\bin\x64\Integration.exe"
goto okExec

:okExec
rem Set default Service name
set SERVICE_NAME=Integration
set DISPLAYNAME=Hanshow %SERVICE_NAME%

if "x%1x" == "xx" goto displayUsage
set SERVICE_CMD=%1
shift
if "x%1x" == "xx" goto checkServiceCmd
:checkUser
if "x%1x" == "x/userx" goto runAsUser
if "x%1x" == "x--userx" goto runAsUser
set SERVICE_NAME=%1	
set DISPLAYNAME=%1
shift
if "x%1x" == "xx" goto checkServiceCmd
goto checkUser
:runAsUser
shift
if "x%1x" == "xx" goto displayUsage
set SERVICE_USER=%1
shift
runas /env /savecred /user:%SERVICE_USER% "%COMSPEC% /K \"%SELF%\" %SERVICE_CMD% %SERVICE_NAME%"
goto end
:checkServiceCmd
if /i %SERVICE_CMD% == install goto doInstall
if /i %SERVICE_CMD% == remove goto doRemove
if /i %SERVICE_CMD% == uninstall goto doRemove
echo Unknown parameter "%SERVICE_CMD%"
:displayUsage
echo.
echo Usage: service.bat install/remove [service_name] [/user username]
goto end

:doRemove
rem Remove the service
echo Removing the service '%SERVICE_NAME%' ...
echo Using APP_HOME:    "%APP_HOME%"
"%EXECUTABLE%" //DS//%SERVICE_NAME% ^
    --LogPath "%APP_HOME%\log"
if not errorlevel 1 goto removed
echo Failed removing '%SERVICE_NAME%' service
goto end
:removed
echo The service '%SERVICE_NAME%' has been removed.
goto end

:doInstall
rem Install the service
echo Installing the service '%SERVICE_NAME%' ...
echo Using APP_HOME:         "%APP_HOME%"
echo Using JAVA_HOME:        "%JAVA_HOME%"
echo Using JRE_HOME:         "%JRE_HOME%"

rem Try to use the server jvm
set "JVM=%JRE_HOME%\bin\server\jvm.dll"
if exist "%JVM%" goto foundJvm
rem Try to use the client jvm
set "JVM=%JRE_HOME%\bin\client\jvm.dll"
if exist "%JVM%" goto foundJvm
echo Warning: Neither 'server' nor 'client' jvm.dll was found at JRE_HOME.
set JVM=auto
:foundJvm
echo Using JVM:              "%JVM%"

set "CLASSPATH=%APP_HOME%\;%APP_HOME%\config"
set DEFAULT_JVM_OPTS="-XX:+UseParallelGC;-Xms1024m;-Xmx1024m;-Dfile.encoding=UTF-8;-Duser.language=en;-Djava.ext.dirs="%APP_HOME%\lib";-Dintegration.home="%APP_HOME%";"

"%EXECUTABLE%" //IS//%SERVICE_NAME% ^
    --Description "Hanshow Integration - http://www.hanshow.com/" ^
    --DisplayName "%DISPLAYNAME%" ^
    --Install "%EXECUTABLE%" ^
    --LogPath "%APP_HOME%\log" ^
    --StdError auto ^
    --Startup auto ^
    --Classpath "%CLASSPATH%" ^
    --Jvm "%JVM%" ^
    --StartMode jvm ^
    --StopMode jvm ^
    --StartPath "%APP_HOME%" ^
    --StopPath "%APP_HOME%" ^
    --StartClass com.hanshows.cdi.yonghuichaoshi.DataExtractor ^
    --StopClass com.hanshows.cdi.yonghuichaoshi.DataExtractor ^
    --StartMethod start ^
    --StopMethod stop ^
    --JvmOptions "%DEFAULT_JVM_OPTS%"
if not errorlevel 1 goto installed
echo Failed installing '%SERVICE_NAME%' service
goto end
:installed
echo The service '%SERVICE_NAME%' has been installed.

:end
cd "%CURRENT_DIR%"
